% This function calcuate the profit at given input
% note that x contain input as well the domestic output if the firm is
% exporting
% Input x = (L, M0, q, QD)
% 1 means export
function [profit, QX] = ProfitFun_1(x,omega, capital, P0, PL, est) % the output reports QX, since we need to make sure it is non-negative
%% specify the variables
    L  = x(1);
    M = x(2);
    log_q = x(3);
    q = exp(log_q);
    PM = P0*q^(est.phi-1);
    h = (est.beta*exp(est.theta*omega) + (1-est.beta)*q^est.theta).^(est.kappa/est.theta);

    QD = x(4);
    QX = getProduction(h, L,M,capital,est) - QD;
%% calculate the profit
profit = est.p_idx_D .* QD.^(1+1/est.etaD) +  est.ka .* est.p_idx_X .* QX.^(1+1/est.etaX) - PL.*L - PM.*M;